from vcCommand import *
from vcHelpers.Application import *
import vcMatrix

app = getApplication()
camera = app.findCamera()
selectionManager = app.SelectionManager

def OnSetOrigin(arg):
  targetComponent = app.findComponent("Part")
  if targetComponent:  
    transform = targetComponent.findFeature("Transform")    
    centerX = targetComponent.Geometry.BoundCenter.X
    centerY = targetComponent.Geometry.BoundCenter.Y
    transform.Expression = "Rz(RotateAngle).Sx(Size/100.0).Sy(Size/100.0).Sz(-Thickness*10.0).Tx(-%f).Ty(-%f)" % (centerX, centerY)
    targetComponent.rebuild()
    app.render()
    
def OnCreate(arg):
  targetComponent = app.findComponent("Part")
  if targetComponent:
    targetComponent.delete()
    
  targetComponent = app.createComponent()
  targetProdID = targetComponent.createProperty(VC_STRING, "ProdID")
  targetSize = targetComponent.createProperty(VC_REAL, "Size")
  targetThickness = targetComponent.createProperty(VC_REAL, "Thickness")
  targetRotateAngle = targetComponent.createProperty(VC_REAL, "RotateAngle")
  
  targetSize.ChangeOnRebuild = True
  targetThickness.ChangeOnRebuild = True
  targetRotateAngle.ChangeOnRebuild = True
  
  # targetComponent.Name = "Part"
  targetComponent.BackfaceMode = VC_FORCE_BACKFACE_ON
  targetComponent.Material = partMaterial.Value
  targetComponent.ProdID = partName.Value      
  targetComponent.Size = partSize.Value
  targetComponent.Thickness = partThickness.Value
  targetComponent.RotateAngle = partRotateAngle.Value
  targetComponent.BOM = False 
  targetComponent.BOMname = partName.Value
  
  transform = targetComponent.RootFeature.createFeature(VC_TRANSFORM, "Transform")
  transform.Expression = "Rz(RotateAngle).Sx(Size/100.0).Sy(Size/100.0).Sz(-Thickness*10.0)"
  text = transform.createFeature(VC_TEXT, "Text") 
  text.Text = "\"%s\"" % partName.Value
  text.Size = 100.0  
 
  targetComponent.rebuild()
 
def OnStart():
  global diag, partName, partMaterial, partSize, partThickness, partRotateAngle
    
  diag = getDialog(Caption = "PartCreator")
  partName = diag.addProperty("PartName", VC_STRING, None)
  partName.Value = "PART"
  partMaterial = diag.addProperty("PartMaterial", "Ref<Material>", None)
  partMaterial.Value = app.findMaterial("black_matte")
  partSize = diag.addProperty("PartSize", VC_REAL, None)
  partSize.Quantity = "Distance"
  partSize.Value = 100.0
  partThickness = diag.addProperty("PartThickness", VC_REAL, None)
  partThickness.Quantity = "Distance"
  partThickness.Value = 10.0  
  partRotateAngle = diag.addProperty("PartRotateAngle", VC_REAL, None)
  partRotateAngle.Quantity = "Angle"
  partRotateAngle.Value = 0.0  
  create = diag.addProperty("Create", VC_BUTTON, OnCreate)
  
  setOrigin = diag.addProperty("SetOrigin", VC_BUTTON, OnSetOrigin)
  
  diag.show()
  